% NEPOMENA: dodatak uz ovu m-skirptu je skup funkcija (primjera) koje su
% definirane u posebnim datotekama. Svaka od tih funkcija ima naziv oblinka
% ImeFuncije_primjer_x
% gdje je ImeFunkcije promjenjivi dio koji sadrzi neko prikladno ime, a
% primjer_x se mijenja ovisno o broju primjera, gdje je taj broj definiran
% u ovoj datoteci koju sada citate.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% naredba FUNCTION koristi se za kreiranje nove funkcije.

% Nove funkcije sadravaju stare, a spremaju se u datoteku s imenom istim
% kao ime funkcije (---> VAZNO!)
% uz ekstenziju '.m'. 
% Pocetak datoteke je sintakticki cvrsto odredjen. 
% Komentar poslije funkcijske definicije koristi se u help-u.

% Sve varijable koje se definiraju unutar funcije ostaju lokalno
% definirane, tj. njihovim vrijednostim se ne moze pristupiti iz globalnog
% sucelja (npr. iz "Command Window"-a); nisu u globalnoj radnoj okolini

% osnovne informacije o sintaksi definiranja funkcije:

help function

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PRIMJER 1 : definiranje funkcije
% Vidjeti datoteku: stat_primjer_1


% pogledajte objasnjenje funkcije:
help stat_primjer_1   % izlistati ce nam "help" uputstva koja smo sami napisali u funkciji stat_primjer_1

%pogledajte cjelokupni kod funkcije:
edit stat_primjer_1


[a,b]=stat_primjer_1([1,2,3,4,5,6,7])       % poziv nase prve funcije koju smo sami napisali

%%%%%%%%%%%%%
SrednjeVrijednosti=[];
StandardneDevijacije=[];
for i=1:50
    if i<=25
        [a,b]=stat_primjer_1(rand(1,100));
    else
        [a,b]=stat_primjer_1(rand(1,100000));
    end
 SrednjeVrijednosti(end+1)=a;
StandardneDevijacije(end+1)=b;
end

figure(1)
plot(SrednjeVrijednosti)
figure(2)
plot(StandardneDevijacije)

help rand
help plot
%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    PRIMJER 2: podfunckije
%   Vidjeti datoteku: stat_primjer_2

% Podfunkcija (subfunction) koja je vidljiva drugim funkcijama unutar 
% iste datoteke definira se nakon vec napisane funkcije.

% Podfunkcije nisu vidljive izvan datoteke u kojoj su definirane.

% Pogledajte kod funkcije stat_primjer_2

% pogledajte objasnjenje funkcije:
help stat_primjer_2


%pogledajte cjelokupni kod funkcije:
edit stat_primjer_2

% podfuncija "avg" nije vidljiva u globalnom okruzju:
help avg

[a,b]=stat_primjer_2([1,2,3,4,5,6,7])    % daje isti rezultat kao stat_primjer_1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     PRIMJER 3:   naredba "nargout" i definiranje funkcija sa razlicitm mogucim brojem izlaza 
%     Za objasnjenje primjera i naredbe "nargout" vidjeti datoteku: stat_primjer_3

help nargout  % nargout = broj izlaza funcije

% pogledajte objasnjenje funkcije:
help stat_primjer_3

%pogledajte cjelokupni kod funkcije:
edit stat_primjer_3

stat_primjer_3([12 3 4 5 -4 5])   % poziv funkcije bez definiranog broja izaza = dat ce se jedan izlaz i to prvi definirani izaz
[a,b]=stat_primjer_3([12 3 4 5 -4 5]) % poziv funkcije sa dva izlaza
[a,b,c]=stat_primjer_3([12 3 4 5 -4 5]) % poziv funkcije sa tri izlaza
[a,b,c,d]=stat_primjer_3([12 3 4 5 -4 5]) % poziv funkcije sa cetiri izlaza

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     PRIMJER 4: naredba "nargin" i definiranje funcije sa razlicitim mogucim brojem ulaza
%
%     Za objasnjenje primjera i naredbe vidjeti datoteku:
%     suma_primjer_4

help nargin  % nargin = broj ulaznih argumanata funcije, tj. broj argumenata s kojim je korisnik pozvao funkciju

% pogledajte objasnjenje funkcije:
help suma_primjer_4

%pogledajte cjelokupni kod funkcije:
edit suma_primjer_4

suma_primjer_4(1,2)
suma_primjer_4(1)
suma_primjer_4()
suma_primjer_4(1,2,5)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     PRIMJER 5: naredba "varargin" i definicija funcije za varijabilnim
%     brojem argumenata funkcije
% 
%     Za objasnjenje primjera i naredbe vidjeti datoteku:
%     arg_primjer_5

help varargin  % nargout = broj ulaznih argumanata funcije, tj. broj argumenata s kojim je korisnik pozvao funkciju

% pogledajte objasnjenje funkcije:
help arg_primjer_5

%pogledajte cjelokupni kod funkcije:
edit arg_primjer_5

[n1,c1]=arg_primjer_5(1,4,2)
[n2,c2]=arg_primjer_5(1,4,2,-5,3,-4)

c1{1} 

for i=1:n1
c1{i}
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      PRIMJER 6: 
%      potrebno je napisati funkciju koja ima proizvoljan broj ulaznih
%      argumenata, svaki argument je realan broj.
%     Ako korisnik pozove funciju sa jednim izlazom, funcija kao izaz daje
%     sumu svih argumenata.
%    Ako korisnik pozove funciju sa sva izlaza, prvi izlaz je suma svih
%    argumanta, a drugu uzlaz ja omjer najveceg i najmanjeg argumenta.

% Za rjesenje vidi kod funcije suma_primjer_6

edit suma_primjer_6

suma = suma_primjer_6( 1,2,3 )

[suma,omjer]=suma_primjer_6( 1,2,3 )
[suma,omjer]=suma_primjer_6( 0,1,2,3,-1,1,1,1,2,3,4)


%%%%%%%%%%%%%%%%%%%%55








